﻿namespace TabsStudioTrackEd
{
    class RunningDocTableEventsSink : Microsoft.VisualStudio.Shell.Interop.IVsRunningDocTableEvents
    {
        public delegate void DocDataChangedDelegate(string file, Microsoft.VisualStudio.Shell.Interop.__VSRDTATTRIB a);
        public event DocDataChangedDelegate DocDataChanged;

        public RunningDocTableEventsSink(Microsoft.VisualStudio.Shell.Interop.IVsRunningDocumentTable rdt_)
        {
            rdt = rdt_;
        }

        public int OnAfterAttributeChange(uint docCookie, uint grfAttribs)
        {
            try
            {
                Microsoft.VisualStudio.Shell.Interop.__VSRDTATTRIB a = (Microsoft.VisualStudio.Shell.Interop.__VSRDTATTRIB)grfAttribs;
                if (a == Microsoft.VisualStudio.Shell.Interop.__VSRDTATTRIB.RDTA_DocDataIsDirty ||
                    a == Microsoft.VisualStudio.Shell.Interop.__VSRDTATTRIB.RDTA_DocDataIsNotDirty ||
                    a == Microsoft.VisualStudio.Shell.Interop.__VSRDTATTRIB.RDTA_DocDataReloaded)
                {
                    uint pgrfRDTFlags;
                    uint pdwReadLocks;
                    uint pdwEditLocks;
                    string pbstrMkDocument;
                    Microsoft.VisualStudio.Shell.Interop.IVsHierarchy ppHier;
                    uint pitemid;
                    System.IntPtr ppunkDocData;
                    if (rdt.GetDocumentInfo(docCookie, out pgrfRDTFlags, out pdwReadLocks, out pdwEditLocks, out pbstrMkDocument,
                        out ppHier, out pitemid, out ppunkDocData) == Microsoft.VisualStudio.VSConstants.S_OK)
                    {
                        if (DocDataChanged != null)
                            DocDataChanged(pbstrMkDocument, a);
                    }
                }
            }
            catch (System.Exception ex)
            {
                System.Windows.MessageBox.Show(ex.Message + System.Environment.NewLine + ex.StackTrace,
                    "TrackEd (Unhandled exception)",
                    System.Windows.MessageBoxButton.OK, System.Windows.MessageBoxImage.Error);
            }
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int OnAfterDocumentWindowHide(uint docCookie, Microsoft.VisualStudio.Shell.Interop.IVsWindowFrame pFrame)
        {
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int OnAfterFirstDocumentLock(uint docCookie, uint dwRDTLockType, uint dwReadLocksRemaining, uint dwEditLocksRemaining)
        {
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int OnAfterSave(uint docCookie)
        {
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int OnBeforeDocumentWindowShow(uint docCookie, int fFirstShow, Microsoft.VisualStudio.Shell.Interop.IVsWindowFrame pFrame)
        {
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        public int OnBeforeLastDocumentUnlock(uint docCookie, uint dwRDTLockType, uint dwReadLocksRemaining, uint dwEditLocksRemaining)
        {
            return Microsoft.VisualStudio.VSConstants.S_OK;
        }

        private Microsoft.VisualStudio.Shell.Interop.IVsRunningDocumentTable rdt;
    }
}
